using System;
using System.Collections.Generic;
using System.Text;
using System.IO;

namespace MinorShift.Emuera.Sub
{
	internal enum EraDataState
	{
		OK = 0,//[h\
		FILENOTFOUND = 1,//t@C݂
		GAME_ERROR = 2,//Q[Ⴄ
		VIRSION_ERROR = 3,//o[WႤ
		ETC_ERROR = 4,//̑̃G[

	}

	internal sealed class EraDataResult
	{
		public EraDataState State = EraDataState.OK;
		public string DataMes = "";
	}

	/// <summary>
	/// Z[uf[^ǂݎ
	/// </summary>
	internal sealed class EraDataReader : IDisposable
	{
		public EraDataReader(StreamReader stream)
		{
			reader = stream;
		}
		StreamReader reader;
		public const string FINISHER = "__FINISHED";
		public const string EMU_START = "__EMUERA_STRAT__";
		public const string EMU_SEPARATOR = "__EMU_SEPARATOR__";
#region eramaker
		public string ReadString()
		{
			if (reader == null)
				throw new FileEE("ȃXg[ł");
			string str = reader.ReadLine();
			if(str == null)
				throw new FileEE("ǂݎׂ񂪂܂");
			return str;
		}

		public Int64 ReadInt64()
		{
			if (reader == null)
				throw new FileEE("ȃXg[ł");
			Int64 ret = 0;
			string str = reader.ReadLine();
			if (str == null)
				throw new FileEE("ǂݎׂl܂");
			if (!Int64.TryParse(str, out ret))
				throw new FileEE("lƂĔFł܂");
			return ret;
		}


		public void ReadInt64Array(Int64[] array)
		{
			if (reader == null)
				throw new FileEE("ȃXg[ł");
			if (array == null)
				throw new FileEE("Ȕz񂪓n܂");
			int i = -1;
			string str = null;
			Int64 integer = 0;
			i = -1;
			while (true)
			{
				i++;
				str = reader.ReadLine();
				if (str == null)
					throw new FileEE("\ȂZ[uf[^̏I[ł");
				if (str.Equals(FINISHER, StringComparison.Ordinal))
					break;
				if (i >= array.Length)//z𒴂ĕۑĂĂȂœǂݔ΂B
					continue;
				if (!Int64.TryParse(str, out integer))
					throw new FileEE("lƂĔFł܂");
				array[i] = integer;
			}
			for (; i < array.Length; i++)//ۑĂlȂ0ɏ
				array[i] = 0;
		}

		public void ReadStringArray(string[] array)
		{
			if (reader == null)
				throw new FileEE("ȃXg[ł");
			if (array == null)
				throw new FileEE("Ȕz񂪓n܂");
			int i = -1;
			string str = null;
			i = -1;
			while (true)
			{
				i++;
				str = reader.ReadLine();
				if (str == null)
					throw new FileEE("\ȂZ[uf[^̏I[ł");
				if (str.Equals(FINISHER, StringComparison.Ordinal))
					break;
				if (i >= array.Length)//z𒴂ĕۑĂĂȂœǂݔ΂B
					continue;
				array[i] = str;
			}
			for (; i < array.Length; i++)//ۑĂlȂ""ɏ
				array[i] = "";
		}
#endregion
#region Emuera
		public bool SeekEmuStart()
		{

			if (reader == null)
				throw new FileEE("ȃXg[ł");
			if (reader.EndOfStream)
				return false;
			while (true)
			{
				string str = reader.ReadLine();
				if (str == null)
					return false;
				if (str == EMU_START)
					return true;
			}
		}

		public Dictionary<string, string> ReadStringExtended()
		{
			if (reader == null)
				throw new FileEE("ȃXg[ł");
			Dictionary<string, string> strList = new Dictionary<string, string>();
			string str = null;
			while (true)
			{
				str = reader.ReadLine();
				if (str == null)
					throw new FileEE("\ȂZ[uf[^̏I[ł");
				if (str.Equals(FINISHER, StringComparison.Ordinal))
					throw new FileEE("Z[uf[^̌`sł");
				if (str.Equals(EMU_SEPARATOR, StringComparison.Ordinal))
					break;
				int index = str.IndexOf(':');
				if (index < 0)
					throw new FileEE("Z[uf[^̌`sł");
				string key  = str.Substring(0, index);
				string value  = str.Substring(index + 1, str.Length - index - 1);
				if(!strList.ContainsKey(key))
					strList.Add(key, value);
			}
			return strList;
		}
		public Dictionary<string, Int64> ReadInt64Extended()
		{
			if (reader == null)
				throw new FileEE("ȃXg[ł");
			Dictionary<string, Int64> intList = new Dictionary<string, Int64>();
			string str = null;
			while (true)
			{
				str = reader.ReadLine();
				if (str == null)
					throw new FileEE("\ȂZ[uf[^̏I[ł");
				if (str.Equals(FINISHER, StringComparison.Ordinal))
					throw new FileEE("Z[uf[^̌`sł");
				if (str.Equals(EMU_SEPARATOR, StringComparison.Ordinal))
					break;
				int index = str.IndexOf(':');
				if (index < 0)
					throw new FileEE("Z[uf[^̌`sł");
				string key = str.Substring(0, index);
				string valueStr = str.Substring(index + 1, str.Length - index - 1);
				Int64 value = 0;
				if (!Int64.TryParse(valueStr, out value))
					throw new FileEE("lƂĔFł܂");
				if (!intList.ContainsKey(key))
					intList.Add(key, value);
			}
			return intList;
		}

		public Dictionary<string, List<Int64>> ReadInt64ArrayExtended()
		{
			if (reader == null)
				throw new FileEE("ȃXg[ł");
			Dictionary<string, List<Int64>> ret = new Dictionary<string, List<Int64>>();
			string str = null;
			while (true)
			{
				str = reader.ReadLine();
				if (str == null)
					throw new FileEE("\ȂZ[uf[^̏I[ł");
				if (str.Equals(FINISHER, StringComparison.Ordinal))
					throw new FileEE("Z[uf[^̌`sł");
				if (str.Equals(EMU_SEPARATOR, StringComparison.Ordinal))
					break;
						string key = str;
				List<Int64> valueList = new List<Int64>();
				while (true)
				{
					str = reader.ReadLine();
					if (str == null)
						throw new FileEE("\ȂZ[uf[^̏I[ł");
					if (str.Equals(EMU_SEPARATOR, StringComparison.Ordinal))
						throw new FileEE("Z[uf[^̌`sł");
					if (str.Equals(FINISHER, StringComparison.Ordinal))
						break;
					Int64 value = 0;
					if (!Int64.TryParse(str, out value))
						throw new FileEE("lƂĔFł܂");
					valueList.Add(value);
				}
				if (!ret.ContainsKey(key))
					ret.Add(key, valueList);
			}
			return ret;
		}

		public Dictionary<string, List<string>> ReadStringArrayExtended()
		{
			if (reader == null)
				throw new FileEE("ȃXg[ł");
			Dictionary<string, List<string>> ret = new Dictionary<string, List<string>>();
			string str = null;
			while (true)
			{
				str = reader.ReadLine();
				if (str == null)
					throw new FileEE("\ȂZ[uf[^̏I[ł");
				if (str.Equals(FINISHER, StringComparison.Ordinal))
					throw new FileEE("Z[uf[^̌`sł");
				if (str.Equals(EMU_SEPARATOR, StringComparison.Ordinal))
					break;
				string key = str;
				List<string> valueList = new List<string>();
				while (true)
				{
					str = reader.ReadLine();
					if (str == null)
						throw new FileEE("\ȂZ[uf[^̏I[ł");
					if (str.Equals(EMU_SEPARATOR, StringComparison.Ordinal))
						throw new FileEE("Z[uf[^̌`sł");
					if (str.Equals(FINISHER, StringComparison.Ordinal))
						break;
					valueList.Add(str);
				}
				if (!ret.ContainsKey(key))
					ret.Add(key, valueList);
			}
			return ret;
		}
#endregion
		#region IDisposable o

		public void Dispose()
		{
			if (reader != null)
				reader.Close();
			reader = null;
		}

		#endregion
		public void Close()
		{
			this.Dispose();
		}

	}

	/// <summary>
	/// Z[uf[^
	/// </summary>
	internal sealed class EraDataWriter : IDisposable
	{
		public EraDataWriter(StreamWriter stream)
		{
			writer = stream;
		}

		public const string FINISHER = EraDataReader.FINISHER;
		public const string EMU_START = EraDataReader.EMU_START;
		public const string EMU_SEPARATOR = EraDataReader.EMU_SEPARATOR;
		StreamWriter writer;
#region eramaker
		public void Write(Int64 integer)
		{
			if (writer == null)
				throw new FileEE("ȃXg[ł");
			writer.WriteLine(integer.ToString());
		}


		public void Write(string str)
		{
			if (writer == null)
				throw new FileEE("ȃXg[ł");
			if (str == null)
				writer.WriteLine("");
			else
				writer.WriteLine(str);
		}

		public void Write(Int64[] array)
		{
			if (writer == null)
				throw new FileEE("ȃXg[ł");
			if (array == null)
				throw new FileEE("Ȕz񂪓n܂");
			int count = -1;
			for (int i = 0; i < array.Length; i++)
				if (array[i] != 0)
					count = i;
			count++;
			for (int i = 0; i < count; i++)
				writer.WriteLine(array[i].ToString());
			writer.WriteLine(FINISHER);
		}
		public void Write(string[] array)
		{
			if (writer == null)
				throw new FileEE("ȃXg[ł");
			if (array == null)
				throw new FileEE("Ȕz񂪓n܂");
			int count = -1;
			for (int i = 0; i < array.Length; i++)
				if (!string.IsNullOrEmpty(array[i]))
					count = i;
			count++;
			for (int i = 0; i < count; i++)
			{
				if (array[i] == null)
					writer.WriteLine("");
				else
					writer.WriteLine(array[i]);
			}
			writer.WriteLine(FINISHER);
		}
#endregion
#region Emuera

		public void EmuStart()
		{
			if (writer == null)
				throw new FileEE("ȃXg[ł");
			writer.WriteLine(EMU_START);
		}
		public void EmuSeparete()
		{
			if (writer == null)
				throw new FileEE("ȃXg[ł");
			writer.WriteLine(EMU_SEPARATOR);
		}

		public void WriteExtended(string key, Int64 value)
		{
			if (writer == null)
				throw new FileEE("ȃXg[ł");
			if (value == 0)
				return;
			writer.WriteLine(string.Format("{0}:{1}", key, value));
		}

		public void WriteExtended(string key, string value)
		{
			if (writer == null)
				throw new FileEE("ȃXg[ł");
			if (string.IsNullOrEmpty(value))
				return;
			writer.WriteLine(string.Format("{0}:{1}", key, value));
		}


		public void WriteExtended(string key, Int64[] array)
		{
			if (writer == null)
				throw new FileEE("ȃXg[ł");
			if (array == null)
				throw new FileEE("Ȕz񂪓n܂");
			int count = -1;
			for (int i = 0; i < array.Length; i++)
				if (array[i] != 0)
					count = i;
			count++;
			if (count == 0)
				return;
			writer.WriteLine(key);
			for (int i = 0; i < count; i++)
				writer.WriteLine(array[i].ToString());
			writer.WriteLine(FINISHER);
		}
		public void WriteExtended(string key, string[] array)
		{
			if (writer == null)
				throw new FileEE("ȃXg[ł");
			if (array == null)
				throw new FileEE("Ȕz񂪓n܂");
			int count = -1;
			for (int i = 0; i < array.Length; i++)
				if (!string.IsNullOrEmpty(array[i]))
					count = i;
			count++;
			if (count == 0)
				return;
			writer.WriteLine(key);
			for (int i = 0; i < count; i++)
			{
				if (array[i] == null)
					writer.WriteLine("");
				else
					writer.WriteLine(array[i]);
			}
			writer.WriteLine(FINISHER);
		}
#endregion

		#region IDisposable o

		public void Dispose()
		{
			if (writer != null)
				writer.Close();
			writer = null;
		}

		#endregion
		public void Close()
		{
			this.Dispose();
		}
	}
}
